/* [styx_pim.c] Parser table for 'styx'  */



#include "prs.h"

#include "prs_imp.h"


static string styx_SNames[] = {
  "Parenthesis", "Comment", "Ide", "Nat", "Opr", 
  "Set", "Seq", "MacInc", "MacDel", "MacDfn", 
  "MacSep", "MacCond", "Language", "Context", "Free", 
  "Grammar", "Regular", "=", "tok", "<", 
  ">", "InGroup", "ExGroup", "Group", "let", 
  "ign", "com", "lan", "ind", ":", 
  "!", "!+", "!-", "[", "ica", 
  "]", "/", "?", "|", "-", 
  ",", "{", "}", "*", "+", 
  "..", "(", ")", "xtop", "start", 
  "err", "other", "...", ".", "reduce", 
  "Source", "OptCfg", "QlxDfns0", "QlxDfns", "QlxDfn", 
  "Ids0", "Ids", "QlxCat", "QlxGrp", "QlxGrp0", 
  "QlxGrp1", "QlxOpt", "ExpQuot", "ExpDyck", "Exp0", 
  "Exp", "Exp1", "OptNat", "Limit", "Exp2", 
  "Exp3", "Exp4", "Dfns", "Dfn", "Cat0", 
  "Cat", "DfnOpt", "Prds", "Lay", "Prd", 
  "Mbrs", "Mbr", "Mbr1", "OptKey", "Conflicts", 
  "Conflict", "State", "Token", "Rules0", "Rules", 
  "Rule"
};

static int styx_StartIds[] = {
  55
};

static int styx_TokKind[] = {
  1, 6, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2
};

static int styx_NtClass[] = {
  0, 1, 3, 3, 4, 6, 6, 7, 
  8, 8, 8, 11, 15, 15, 15, 15, 
  15, 17, 18, 15, 15, 15, 22, 23, 
  25, 25, 26, 27, 28, 29, 30, 31, 
  31, 33, 34, 35, 36, 37, 39, 39, 
  40
};

static c_bool styx_ErrorNt[] = {
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 
  0
};

static KFGHEAD styx_KfgHead = {
  "styx",
  55, 41, styx_SNames,
  1, styx_StartIds,
  styx_TokKind,
  styx_NtClass,
  styx_ErrorNt
};

static int styx_PSymbols[] = {
  12, 72, 2, 57, 56,
  13, 14, 15, 77, 89,
  16, 15, 58,
  59, 58,
  62, 66, 64, 2, 65, 17, 67,
  18, 19, 2, 20,
  21, 2,
  22, 2,
  23, 2, 17, 61,
  2, 60,
  2, 60,
  24,
  18,
  25,
  26,
  27,
  28,
  29, 2, 29,
  63,
  30, 2,
  30,
  31, 2,
  31,
  32,
  63,
  33, 34, 35,
  68, 36, 76,
  68,
  19, 70, 20, 69, 19, 70, 20,
  19, 17, 69, 20, 5, 19, 69, 20,
  19, 37, 69, 20, 2, 19, 69, 20,
  70,
  70,
  70, 38, 71,
  70, 39, 71,
  71,
  71, 74,
  74,
  3,
  3,
  3, 40, 72,
  33, 70, 35,
  41, 70, 42,
  75, 43,
  75, 44,
  75, 73,
  75,
  76,
  76, 45, 76,
  46, 70, 47,
  6,
  5,
  2,
  78, 77,
  80, 81, 2, 82,
  48,
  24,
  49,
  79,
  33, 50, 35,
  84, 82,
  29,
  37,
  30,
  83, 2, 29, 85,
  86, 85,
  6,
  33, 51, 35,
  87,
  2,
  33, 88, 87, 88, 52, 88, 35,
  46, 88, 87, 88, 52, 88, 47,
  33, 88, 87, 88, 35,
  2, 19, 2, 20,
  6, 88,
  90, 89,
  13, 91, 53, 92, 29, 94,
  3,
  6,
  2,
  6,
  2,
  95, 93,
  95, 93,
  54, 2, 53, 2,
  55
};

static int styx_PSymFrms[] = {
  0, 11, 18, 0, 0,
  0, 10, 17, -2, -2,
  0, 10, -2,
  0, 0,
  0, 7, 14, 22, 26, 34, 38,
  0, 6, 10, 14,
  0, 10,
  0, 10,
  0, 10, 14, 18,
  0, 4,
  0, 4,
  0,
  0,
  0,
  0,
  0,
  0,
  0, 4, 8,
  0,
  0, 5,
  0,
  0, 5,
  0,
  0,
  0,
  0, 4, 10,
  0, 8, 12,
  0,
  0, 4, 8, 12, 17, 21, 25,
  0, 4, 8, 13, 17, 21, 25, 30,
  0, 4, 8, 13, 17, 21, 25, 30,
  0,
  0,
  0, 4, 8,
  0, 4, 8,
  0,
  0, 5,
  0,
  0,
  0,
  0, 4, 8,
  0, 4, 8,
  0, 4, 8,
  0, 5,
  0, 5,
  0, 5,
  0,
  0,
  0, 5, 10,
  0, 4, 8,
  0,
  0,
  0,
  0, 0,
  0, 4, 11, 0,
  0,
  0,
  0,
  0,
  0, 4, 10,
  0, 0,
  0,
  0,
  0,
  0, 4, 8, -2,
  0, 0,
  0,
  0, 4, 12,
  0,
  0,
  0, 4, 11, 16, 23, 29, 36,
  0, 4, 11, 16, 23, 29, 36,
  0, 4, 11, 16, 23,
  0, 4, 8, 12,
  0, 4,
  0, 0,
  0, 10, 16, 20, 26, 0,
  0,
  0,
  0,
  0,
  0,
  0, 0,
  0, 0,
  0, 9, 13, 17,
  0
};

static KFGPROD styx_KfgProds[] = {
  { "root", 0, 55, 5, &styx_PSymbols[0], &styx_PSymFrms[0], -1, -1 },
  { "non", 0, 56, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cfg", 0, 56, 5, &styx_PSymbols[5], &styx_PSymFrms[5], -1, -1 },
  { "nil", 0, 57, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 57, 3, &styx_PSymbols[10], &styx_PSymFrms[10], -1, -1 },
  { "nil", 0, 58, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 58, 2, &styx_PSymbols[13], &styx_PSymFrms[13], -1, -1 },
  { "defn", 2, 59, 7, &styx_PSymbols[15], &styx_PSymFrms[15], -1, -1 },
  { "defd", 2, 59, 4, &styx_PSymbols[22], &styx_PSymFrms[22], -1, -1 },
  { "igrp", 2, 59, 2, &styx_PSymbols[26], &styx_PSymFrms[26], -1, -1 },
  { "xgrp", 2, 59, 2, &styx_PSymbols[28], &styx_PSymFrms[28], -1, -1 },
  { "mgrp", 2, 59, 4, &styx_PSymbols[30], &styx_PSymFrms[30], -1, -1 },
  { "nil", 0, 60, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 60, 2, &styx_PSymbols[34], &styx_PSymFrms[34], -1, -1 },
  { "cons", 0, 61, 2, &styx_PSymbols[36], &styx_PSymFrms[36], -1, -1 },
  { "letC", 0, 62, 1, &styx_PSymbols[38], &styx_PSymFrms[38], -1, -1 },
  { "tokC", 0, 62, 1, &styx_PSymbols[39], &styx_PSymFrms[39], -1, -1 },
  { "ignC", 0, 62, 1, &styx_PSymbols[40], &styx_PSymFrms[40], -1, -1 },
  { "comC", 0, 62, 1, &styx_PSymbols[41], &styx_PSymFrms[41], -1, -1 },
  { "lanC", 0, 62, 1, &styx_PSymbols[42], &styx_PSymFrms[42], -1, -1 },
  { "indC", 0, 62, 1, &styx_PSymbols[43], &styx_PSymFrms[43], -1, -1 },
  { "non", 0, 63, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "grp", 0, 64, 3, &styx_PSymbols[44], &styx_PSymFrms[44], -1, -1 },
  { "ign0", 0, 64, 1, &styx_PSymbols[47], &styx_PSymFrms[47], -1, -1 },
  { "grp", 0, 65, 2, &styx_PSymbols[48], &styx_PSymFrms[48], -1, -1 },
  { "igrp", 0, 65, 1, &styx_PSymbols[50], &styx_PSymFrms[50], -1, -1 },
  { "pgrp", 0, 65, 2, &styx_PSymbols[51], &styx_PSymFrms[51], -1, -1 },
  { "pigrp", 0, 65, 1, &styx_PSymbols[53], &styx_PSymFrms[53], -1, -1 },
  { "pop", 0, 65, 1, &styx_PSymbols[54], &styx_PSymFrms[54], -1, -1 },
  { "ign0", 0, 65, 1, &styx_PSymbols[55], &styx_PSymFrms[55], -1, -1 },
  { "non", 0, 66, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ignca", 0, 66, 3, &styx_PSymbols[56], &styx_PSymFrms[56], -1, -1 },
  { "quot", 0, 67, 3, &styx_PSymbols[59], &styx_PSymFrms[59], -1, -1 },
  { "ign0", 0, 67, 1, &styx_PSymbols[62], &styx_PSymFrms[62], -1, -1 },
  { "dyck", 0, 68, 7, &styx_PSymbols[63], &styx_PSymFrms[63], -1, -1 },
  { "spat", 0, 68, 8, &styx_PSymbols[70], &styx_PSymFrms[70], -1, -1 },
  { "epat", 0, 68, 8, &styx_PSymbols[78], &styx_PSymFrms[78], -1, -1 },
  { "ign0", 0, 68, 1, &styx_PSymbols[86], &styx_PSymFrms[86], -1, -1 },
  { "non", 0, 69, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "ign0", 0, 69, 1, &styx_PSymbols[87], &styx_PSymFrms[87], -1, -1 },
  { "union", 0, 70, 3, &styx_PSymbols[88], &styx_PSymFrms[88], -1, -1 },
  { "diff", 0, 70, 3, &styx_PSymbols[91], &styx_PSymFrms[91], -1, -1 },
  { "ign1", 0, 70, 1, &styx_PSymbols[94], &styx_PSymFrms[94], -1, -1 },
  { "conc", 0, 71, 2, &styx_PSymbols[95], &styx_PSymFrms[95], -1, -1 },
  { "ign1", 0, 71, 1, &styx_PSymbols[97], &styx_PSymFrms[97], -1, -1 },
  { "non", 0, 72, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "nat", 0, 72, 1, &styx_PSymbols[98], &styx_PSymFrms[98], -1, -1 },
  { "ntime", 0, 73, 1, &styx_PSymbols[99], &styx_PSymFrms[99], -1, -1 },
  { "range", 0, 73, 3, &styx_PSymbols[100], &styx_PSymFrms[100], -1, -1 },
  { "opt", 0, 74, 3, &styx_PSymbols[103], &styx_PSymFrms[103], -1, -1 },
  { "star", 0, 74, 3, &styx_PSymbols[106], &styx_PSymFrms[106], -1, -1 },
  { "plus0", 0, 74, 2, &styx_PSymbols[109], &styx_PSymFrms[109], -1, -1 },
  { "plus", 0, 74, 2, &styx_PSymbols[111], &styx_PSymFrms[111], -1, -1 },
  { "plusn", 0, 74, 2, &styx_PSymbols[113], &styx_PSymFrms[113], -1, -1 },
  { "ign1", 0, 74, 1, &styx_PSymbols[115], &styx_PSymFrms[115], -1, -1 },
  { "ign1", 0, 75, 1, &styx_PSymbols[116], &styx_PSymFrms[116], -1, -1 },
  { "range", 0, 75, 3, &styx_PSymbols[117], &styx_PSymFrms[117], -1, -1 },
  { "ign2", 0, 75, 3, &styx_PSymbols[120], &styx_PSymFrms[120], -1, -1 },
  { "sequ", 0, 76, 1, &styx_PSymbols[123], &styx_PSymFrms[123], -1, -1 },
  { "set", 0, 76, 1, &styx_PSymbols[124], &styx_PSymFrms[124], -1, -1 },
  { "ident", 0, 76, 1, &styx_PSymbols[125], &styx_PSymFrms[125], -1, -1 },
  { "nil", 0, 77, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 77, 2, &styx_PSymbols[126], &styx_PSymFrms[126], -1, -1 },
  { "defn", 2, 78, 4, &styx_PSymbols[128], &styx_PSymFrms[128], -1, -1 },
  { "bgnC", 0, 79, 1, &styx_PSymbols[132], &styx_PSymFrms[132], -1, -1 },
  { "letC", 0, 80, 1, &styx_PSymbols[133], &styx_PSymFrms[133], -1, -1 },
  { "bgnC", 0, 80, 1, &styx_PSymbols[134], &styx_PSymFrms[134], -1, -1 },
  { "ign0", 0, 80, 1, &styx_PSymbols[135], &styx_PSymFrms[135], -1, -1 },
  { "non", 0, 81, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "errnt", 0, 81, 3, &styx_PSymbols[136], &styx_PSymFrms[136], -1, -1 },
  { "nil", 0, 82, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 82, 2, &styx_PSymbols[139], &styx_PSymFrms[139], -1, -1 },
  { "dft", 0, 83, 1, &styx_PSymbols[141], &styx_PSymFrms[141], -1, -1 },
  { "rec", 0, 83, 1, &styx_PSymbols[142], &styx_PSymFrms[142], -1, -1 },
  { "grp", 0, 83, 1, &styx_PSymbols[143], &styx_PSymFrms[143], -1, -1 },
  { "prod", 1, 84, 4, &styx_PSymbols[144], &styx_PSymFrms[144], -1, -1 },
  { "nil", 0, 85, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 1, 85, 2, &styx_PSymbols[148], &styx_PSymFrms[148], -1, -1 },
  { "tkm", 0, 86, 1, &styx_PSymbols[150], &styx_PSymFrms[150], -1, -1 },
  { "else", 0, 86, 3, &styx_PSymbols[151], &styx_PSymFrms[151], -1, -1 },
  { "ign0", 0, 86, 1, &styx_PSymbols[154], &styx_PSymFrms[154], -1, -1 },
  { "ntm", 0, 87, 1, &styx_PSymbols[155], &styx_PSymFrms[155], -1, -1 },
  { "klst0", 0, 87, 7, &styx_PSymbols[156], &styx_PSymFrms[156], -1, -1 },
  { "klst1", 0, 87, 7, &styx_PSymbols[163], &styx_PSymFrms[163], -1, -1 },
  { "opt", 0, 87, 5, &styx_PSymbols[170], &styx_PSymFrms[170], -1, -1 },
  { "dtok", 0, 87, 4, &styx_PSymbols[175], &styx_PSymFrms[175], -1, -1 },
  { "nil", 0, 88, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 88, 2, &styx_PSymbols[179], &styx_PSymFrms[179], -1, -1 },
  { "nil", 0, 89, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 89, 2, &styx_PSymbols[181], &styx_PSymFrms[181], -1, -1 },
  { "defn", 2, 90, 6, &styx_PSymbols[183], &styx_PSymFrms[183], -1, -1 },
  { "nat", 0, 91, 1, &styx_PSymbols[189], &styx_PSymFrms[189], -1, -1 },
  { "seq", 0, 91, 1, &styx_PSymbols[190], &styx_PSymFrms[190], -1, -1 },
  { "ide", 0, 91, 1, &styx_PSymbols[191], &styx_PSymFrms[191], -1, -1 },
  { "seq", 0, 92, 1, &styx_PSymbols[192], &styx_PSymFrms[192], -1, -1 },
  { "ide", 0, 92, 1, &styx_PSymbols[193], &styx_PSymFrms[193], -1, -1 },
  { "nil", 0, 93, 0, (int*)NULL, (int*)NULL, -1, -1 },
  { "cons", 0, 93, 2, &styx_PSymbols[194], &styx_PSymFrms[194], -1, -1 },
  { "cons", 0, 94, 2, &styx_PSymbols[196], &styx_PSymFrms[196], -1, -1 },
  { "red", 0, 95, 4, &styx_PSymbols[198], &styx_PSymFrms[198], -1, -1 },
  { "Start_Source", 0, 96, 1, &styx_PSymbols[202], &styx_PSymFrms[202], -1, -1 }
};

static int styx_MstShifts[] = {
  1, 3, -1, -1, 5, 7, 9, 11, 
  21, 31, -1, 33, 35, 37, 39, -1, 
  -1, -1, -1, -1, -1, 21, 41, 43, 
  45, -1, -1, 47, -1, 49, 51, 55, 
  59, 61, 63, 65, -1, 67, -1, -1, 
  -1, 69, 55, -1, 71, -1, 73, -1, 
  -1, 75, 79, 85, -1, 69, -1, 89, 
  91, 73, -1, -1, 93, 95, -1, -1, 
  97, -1, -1, -1, 99, -1, 101, 105, 
  -1, -1, -1, 115, 124, -1, -1, -1, 
  -1, -1, 127, 105, -1, -1, -1, 136, 
  150, 150, 150, -1, 157, 160, 150, -1, 
  165, 169, -1, -1, 171, 173, -1, 150, 
  150, 177, 183, 189, 195, 201, 150, 150, 
  -1, 205, -1, -1, -1, 201, 207, 212, 
  217, 160, 219, 150, -1, -1, -1, -1, 
  150, 150, 3, -1, 221, -1, 207, 223, 
  -1, 226, 229, -1, 212, -1, 231, 233, 
  235, -1, 237, -1, 207, 239, 229, 241, 
  245, 245, -1, 249, 251, 150, 253, -1, 
  255, -1, -1, 229, 229, 229, 150, 150, 
  259, -1, -1, 264, 267, 269, 271, -1, 
  -1, 229, 229, -1, -1, 273, 275, -1, 
  -1
};

static int styx_DtlShifts[] = {
  -2, 12, -4, 3, -6, 2, -7, 16, 
  -9, 15, -10, 13, -12, -13, -14, -15, 
  -16, -17, -18, -19, -20, 28, 27, 26, 
  25, 24, 23, 22, 21, 18, -24, 14, 
  -25, 19, -26, 2, -27, 2, -28, 2, 
  -30, 33, -32, 15, -33, 2, -34, 17, 
  -35, 34, -36, 29, -39, -40, -41, 49, 
  48, 24, -46, 20, -47, 2, -49, 35, 
  -50, 2, -51, 2, -52, 13, -56, 33, 
  -58, 2, -60, 29, -61, -62, -63, 32, 
  31, 30, -66, -67, -68, 6, 3, 2, 
  -71, 50, -72, 2, -74, 2, -75, 2, 
  -76, 17, -77, 53, -78, 35, -79, -80, 
  -81, 37, 30, 29, -85, -86, -87, -88, 
  -89, -90, -91, 46, 41, 33, 19, 6, 
  5, 2, -99, -100, 6, 2, -102, 2, 
  -85, -86, -87, -89, -90, -91, -104, -105, 
  37, 17, 46, 41, 33, 6, 5, 2, 
  -85, -86, -87, -89, -90, -91, 46, 41, 
  33, 6, 5, 2, -110, 36, -111, -112, 
  39, 38, -114, -115, -116, 44, 43, 3, 
  -118, 45, -119, 29, -120, 29, -111, -112, 
  -124, 20, 39, 38, -111, -112, -125, 35, 
  39, 38, -111, -112, -126, 42, 39, 38, 
  -111, -112, -127, 47, 39, 38, -85, -86, 
  -87, 6, 5, 2, -131, 40, -133, 54, 
  -136, -137, -138, -139, 46, 33, 6, 2, 
  -143, 20, -144, 20, -147, 2, -150, 19, 
  -151, -152, 51, 6, -151, 6, -156, 5, 
  -157, 2, -158, 19, -159, 53, -161, 2, 
  -163, 35, -136, -139, -164, 33, 46, 2, 
  -167, 19, -168, 19, -170, 2, -171, 20, 
  -111, -112, -176, 20, 39, 38, -177, -178, 
  52, 35, -179, 52, -180, 20, -181, 20, 
  -184, 35, -185, 47
};

static int styx_GoTos[] = {
  0, 2, 4, 6, 10, 13, 17, 19, 
  22, 26, 28, 30, 32, 34, 36, 46, 
  64, 80, 84, 86, 104, 121, 142, 146, 
  149, 152, 155, 157, 161, 164, 167, 171, 
  174, 181, 196, 200, 203, 205, 207, 211, 
  213
};

static int styx_GoToDfts[] = {
  188, -1, 196, -8, 193, -6, 206, 9, 
  214, 22, 207, -9, -22, 244, 47, 258, 
  58, 233, -34, 208, -9, -22, 222, 31, 
  249, 51, 223, -31, 250, -51, 216, -23, 
  277, -76, 278, -76, 306, 104, 308, 105, 
  330, 124, 359, 167, 360, 168, 279, 76, 
  291, 88, 292, 89, 293, 90, 294, 91, 
  307, 104, 105, 124, 167, 168, 354, 158, 
  280, 76, 88, 89, 90, 91, 104, 105, 
  124, 158, 167, 168, 314, 111, 315, 112, 
  190, 2, 331, 131, 302, -97, 281, 76, 
  88, 89, 90, 91, 104, 105, 111, 112, 
  124, 158, 167, 168, 298, 95, 129, 130, 
  282, -76, -88, -89, -90, -91, -95, -104, 
  -105, -111, -112, -124, -129, -130, -158, -167, 
  -168, 283, 76, 88, 89, 90, 91, 95, 
  104, 105, 111, 112, 124, 129, 130, 158, 
  167, 168, 313, 110, 317, 118, 227, 32, 
  240, 43, 228, -32, -43, 229, -32, -43, 
  230, -32, -43, 242, -45, 267, 72, 288, 
  84, 268, -72, -84, 269, -72, -84, 325, 
  120, 340, 141, 326, -120, -141, 327, 120, 
  141, 350, 153, 351, 154, 338, 138, 164, 
  339, 139, 347, 151, 357, 165, 358, 166, 
  367, 178, 368, 179, 238, 42, 255, 54, 
  239, -42, -54, 254, -52, 286, -77, 333, 
  135, 345, 149, 319, -119, 320, 119, 334, 
  135, 149
};

static int styx_ActDfts[] = {
  102, 46, 103, 47, 102, 4, 102, 2, 
  6, 102, 1, 17, 102, 102, 102, 16, 
  18, 19, 20, 21, 5, 6, 31, 102, 
  102, 10, 11, 102, 7, 102, 22, 62, 
  102, 102, 102, 102, 24, 102, 66, 65, 
  67, 89, 62, 68, 69, 9, 13, 12, 
  32, 102, 22, 102, 3, 89, 63, 102, 
  102, 13, 15, 23, 26, 28, 29, 30, 
  102, 94, 92, 93, 102, 90, 102, 71, 
  14, 25, 27, 102, 102, 70, 73, 75, 
  74, 64, 102, 71, 61, 60, 59, 102, 
  102, 102, 102, 8, 34, 38, 43, 45, 
  55, 56, 96, 95, 102, 102, 72, 39, 
  39, 102, 102, 102, 102, 102, 102, 102, 
  44, 48, 52, 53, 54, 102, 102, 77, 
  102, 40, 102, 39, 50, 51, 58, 33, 
  41, 42, 46, 57, 102, 91, 97, 82, 
  79, 87, 87, 76, 77, 81, 102, 102, 
  102, 49, 102, 99, 97, 102, 87, 102, 
  102, 102, 78, 102, 102, 102, 102, 98, 
  102, 88, 80, 87, 87, 87, 39, 39, 
  102, 100, 86, 102, 102, 102, 102, 35, 
  85, 87, 87, 36, 37, 102, 102, 83, 
  84
};


static PARSETAB styx_ParseTab = {
  &styx_KfgHead, 101, styx_KfgProds,
  {
    185, styx_MstShifts, 276, styx_DtlShifts,
    41, styx_GoTos, 218, styx_GoToDfts,
    185, styx_ActDfts, 0, (int*)NULL
  }
};

PLR_Tab PLR_get_styx()
/* simulates a PLR_getTab */
{
  return( PLR_copyTab(&styx_ParseTab) );
}
